function love.load()
  gamename = "template!"
  
  -- font is https://tepokato.itch.io/axolotl-font
  love.graphics.setFont(love.graphics.newFont("assets/Axolotl.ttf", 16))
  -- accurate deltatime
  acdelt = false

  -- import libraries
  -- gamestate, manages gamestates
  gs = require "lib.gamestate"
  -- baton, manages input handling
  baton = require "lib.baton"
  -- good quality:tm: functions, snippets, etc
  helpers = require "lib.helpers"
  -- push, graphics helper, makes screen resolution stuff easy
  push = require "lib.push"
  -- deeper, modification of deep, queue functions, now with even more queue
  deeper = require "lib.deeper"
  -- tesound, sound playback
  te = require"lib.tesound"
  -- lovebird,debugging console
  lovebird = require "lib.lovebird"
  -- entity manager
  em = require "lib.entityman"
  -- spritesheet manager
  ez = require "lib.ezanim"
  -- tween manager
  flux = require "lib.flux"
  -- set size of window
  windowWidth, windowHeight = 800, 450
  
  -- set rescaling filter
  love.graphics.setDefaultFilter("nearest", "nearest")
  
  -- set line style
  love.graphics.setLineStyle("rough")
  love.graphics.setLineJoin("miter")

  -- set game canvas size
  gameWidth, gameHeight = 160,90
  
  -- send these arguments to push
  push:setupScreen(gameWidth, gameHeight, windowWidth, windowHeight, {
    fullscreen = false,
    resizable = true,
    pixelperfect = true
  })
  push:setBorderColor{0,0,0}
  love.window.setTitle(gamename)
  paused = false

  -- start colors table with default colors
  colors = {
    {1,1,1},
    {0,0,0},
    {1,0,77/255}
  }
  --setup input
  maininput = baton.new {
      controls = {
        left = {"key:left", "key:a", "axis:leftx-", "button:dpleft"},
        right = {"key:right", "key:d", "axis:leftx+", "button:dpright"},
        up = {"key:up", "key:w", "axis:lefty-", "button:dpup"},
        down = {"key:down", "key:s", "axis:lefty+", "button:dpdown"},
        accept = {"key:space", "button:a"},
        back = {"button:z", "button:b"}
        
      },
      pairs = {
        lr = {"left", "right", "up", "down"}
      },
        joystick = love.joystick.getJoysticks()[1],
    }
  
  -- init global objects
  entities = {}
  graphics = {}
  -- init states
  states = {
    bootscreen = require "states.bootscreen",
    menu = require "states.menu",
    assault = require "states.assault"
    
  }
  
  gs.registerEvents()
  gs.switch(states.bootscreen)
  

end

function love.resize(w, h)
  push:resize(w, h)
end